<script lang="ts" setup name="BizObjectSelector">
import { getObjectListById } from '@/api/biz/bizObjectApi'
const props = withDefaults(defineProps<{
  modelValue: number
  bizId: number
}>(), {
  modelValue: 0,
  bizId: 0,
})
const emit = defineEmits(['update:modelValue'])
interface BizObject {
  bizId: number
  objectId: number
  objectTitle: string
}
const objectId = computed({
  get: () => {
    return props.modelValue
  },
  set: (val) => {
    emit('update:modelValue', val)
  },
})
const state = reactive({
  loading: false,
  dataList: [] as BizObject[],
})

const getData = async () => {
  const bizId = props.bizId
  if (bizId > 0) {
    state.loading = true
    const { data } = await getObjectListById(bizId)
    state.loading = false
    state.dataList = data
  }
}
onMounted(() => {
  getData ()
})
</script>

<template>
  <el-select v-model="objectId" v-loading="state.loading" style="width: 100%" filterable placeholder="请选择业务对象" value-key="objectId">
    <el-option key="0" label="请选择" :value="0" disabled />
    <el-option
      v-for="item in state.dataList"
      :key="item.objectId"
      :label="item.objectTitle"
      :value="item.objectId"
    />
  </el-select>
</template>
